// Copyright (C) 2002-2012 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in nirtcpp/nirtcpp.hpp

#ifndef NIRT_I_GUI_COLOR_SELECT_DIALOG_HPP_INCLUDED
#define NIRT_I_GUI_COLOR_SELECT_DIALOG_HPP_INCLUDED

#include <nirtcpp/core/engine/IGUIElement.hpp>

namespace nirt
{
namespace gui
{

	//! Standard color chooser dialog.
	class IGUIColorSelectDialog : public IGUIElement
	{
	public:

		//! constructor
		IGUIColorSelectDialog(IGUIEnvironment* environment, IGUIElement* parent, s32 id, core::rect<s32> rectangle)
			: IGUIElement(EGUIET_COLOR_SELECT_DIALOG, environment, parent, id, rectangle) {}

		//! get chosen color as usual SColor class
		virtual video::SColor getColor() =0;

		//! get chosen color as HSL values
		virtual video::SColorHSL getColorHSL() =0;

	};


} // end namespace gui
} // end namespace nirt

#endif
