//
// Copyright (c) 2023-2024 Fas Xmut (fasxmut at protonmail dot com)
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//

#ifndef __nirtcpp_core_engine_device_user_options_hpp__
#define __nirtcpp_core_engine_device_user_options_hpp__

// Device user settings can overwrite settings in include/nirtcpp/NirtCompileConfig.hpp

/*
WARNING: options in this file should be provided by user build option from b2 build system, not from other c++ source code.

Implemented Options List:
	with_windows
	without_windows
	with_x11
	without_x11
	with_osx
	without_osx
	with_sfml
	without_sfml
	with_fb
	without_fb
	with_console
	without_console
*/

/*
#ifdef with_
	#define
#elif defined(without_
	#undef
// #else
	//	// keep
#endif

*/

#ifdef with_windows
	#define _NIRT_COMPILE_WITH_WINDOWS_DEVICE_
	#define _NIRT_WINDOWS_
	#define _NIRT_WINDOWS_API_
#elif defined(without_windows)
	#undef _NIRT_COMPILE_WITH_WINDOWS_DEVICE_
	#undef _NIRT_WINDOWS_
	#undef _NIRT_WINDOWS_API_
// #else
	//	// keep
#endif

#ifdef with_x11
	#define _NIRT_COMPILE_WITH_X11_DEVICE_
#elif defined(without_x11)
	#undef _NIRT_COMPILE_WITH_X11_DEVICE_
// #else
	//	// keep
#endif

#ifdef with_osx
	#define _NIRT_COMPILE_WITH_OSX_DEVICE_
	#define _NIRT_OSX_PLATFORM_
#elif defined(without_osx)
	#undef _NIRT_COMPILE_WITH_OSX_DEVICE_
	#undef _NIRT_OSX_PLATFORM_
// #else
	//	// keep
#endif

#ifdef with_sfml
	#define _NIRT_COMPILE_WITH_SFML_DEVICE_
	#undef NO_NIRT_COMPILE_WITH_SFML_DEVICE_
#elif defined(without_sfml)
	#undef _NIRT_COMPILE_WITH_SFML_DEVICE_
	#define NO_NIRT_COMPILE_WITH_SFML_DEVICE_
// #else
	//	// keep
#endif

#ifdef with_fb
	#define _NIRT_COMPILE_WITH_FB_DEVICE_
#elif defined(without_fb)
	#undef _NIRT_COMPILE_WITH_FB_DEVICE_
// #else
	//	// keep
#endif

#ifdef with_console
	#define _NIRT_COMPILE_WITH_CONSOLE_DEVICE_
	#undef NO_NIRT_COMPILE_WITH_CONSOLE_DEVICE_
#elif defined(without_console)
	#undef _NIRT_COMPILE_WITH_CONSOLE_DEVICE_
	#define NO_NIRT_COMPILE_WITH_CONSOLE_DEVICE_
// #else
	//	// keep
#endif

#endif	// __nirtcpp_core_engine_device_user_options_hpp__

