//
// Copyright (c) 2023 Fas Xmut (fasxmut at protonmail dot com)
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//

// nirtcpp/nirt_types.hpp (Jul. 31, 2023)

#pragma once

#ifndef __nirtcpp_nirt_types_hpp__
#define __nirtcpp_nirt_types_hpp__

#include <nirtcpp/core/engine/irrTypes.hpp>

static_assert(std::unsigned_integral<nirt::u8>);
static_assert(std::unsigned_integral<nirt::u16>);
static_assert(std::unsigned_integral<nirt::u32>);
static_assert(std::unsigned_integral<nirt::u64>);

static_assert(sizeof(nirt::u8)==1);
static_assert(sizeof(nirt::u16)==2);
static_assert(sizeof(nirt::u32)==4);
static_assert(sizeof(nirt::u64)==8);

static_assert(std::signed_integral<nirt::s8>);
static_assert(std::signed_integral<nirt::s16>);
static_assert(std::signed_integral<nirt::s32>);
static_assert(std::signed_integral<nirt::s64>);

static_assert(sizeof(nirt::s8)==1);
static_assert(sizeof(nirt::s16)==2);
static_assert(sizeof(nirt::s32)==4);
static_assert(sizeof(nirt::s64)==8);

#endif // __nirtcpp_nirt_types_hpp__

