// Copyright (C) 2006-2012 Luke Hos.hppke
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in nirtcpp/nirtcpp.hpp

// B3D Mesh loader
// File format designed by Mark Sibly for the Blitz3D engine and has been
// declared public domain

#include <nirtcpp/core/engine/NirtCompileConfig.hpp>

#ifndef SB3DSTRUCTS_H
#define SB3DSTRUCTS_H

#include <nirtcpp/core/engine/SMaterial.hpp>

namespace nirt {
namespace scene {

class SB3dChunkHeader
{
public:
	c8 name[4];
	s32 size;
};

class SB3dChunk
{
public:
	SB3dChunk(const SB3dChunkHeader& header, long sp)
		: length(header.size+8), startposition(sp)
	{
		name[0]=header.name[0];
		name[1]=header.name[1];
		name[2]=header.name[2];
		name[3]=header.name[3];
	}
	c8 name[4];
	s32 length;
	long startposition;
};

class SB3dTexture
{
public:
	core::stringc TextureName;
	s32 Flags;
	s32 Blend;
	f32 Xpos;
	f32 Ypos;
	f32 Xscale;
	f32 Yscale;
	f32 Angle;
};

class SB3dMaterial
{
public:
	SB3dMaterial() : red(1.0f), green(1.0f),
		blue(1.0f), alpha(1.0f), shininess(0.0f), blend(1),
		fx(0)
	{
		for (u32 i=0; i<video::MATERIAL_MAX_TEXTURES; ++i)
			Textures[i]=0;
	}
	video::SMaterial Material;
	f32 red, green, blue, alpha;
	f32 shininess;
	s32 blend,fx;
	SB3dTexture *Textures[video::MATERIAL_MAX_TEXTURES];
};

} // end namespace scene
} // end namespace nirt

#endif
